#pragma once

#include "Algorithms.h"

namespace Decomposition
{
  template<typename MatrixType, template<typename MatrixType> class DecompositionAlgorithm = Algorithms::FullPivoting > 
  class LU : public DecompositionAlgorithm<MatrixType>
  {
  public:
    // the common interface ...
    int rank() const { return 0; }
    bool isInvertible() const { return false; }
  };
}
